<template>
  <div class="card">
    <div class="card-header">
      <h1 class="card-text">Heroes y Villanos Detalle</h1>
    </div>
    <div class="card-body">
      <div class="row justify-content-center align-items-center">
        <div class="col-auto p-5">
          <div v-if="heroe.length != 0">
            <ul class="list-group list-group-horizontal">
              <li class="list-group-item flex-fill font-weight-bold">Nombre:</li>
              <li class="list-group-item flex-fill">{{heroe.nombre | capitalize}}</li>
            </ul>
            <ul class="list-group list-group-horizontal">
              <li class="list-group-item flex-fill font-weight-bold">Alias:</li>
              <li class="list-group-item flex-fill">{{heroe.alias | capitalize}}</li>
            </ul>
            <ul class="list-group list-group-horizontal">
              <li class="list-group-item flex-fill font-weight-bold">Genero:</li>
              <li class="list-group-item flex-fill">{{heroe.genero | capitalize}}</li>
            </ul>
            <ul class="list-group list-group-horizontal">
              <li class="list-group-item flex-fill font-weight-bold">Ocupacion:</li>
              <li class="list-group-item flex-fill">{{heroe.ocupacion | capitalize}}</li>
            </ul>
            <ul class="list-group list-group-horizontal">
              <li class="list-group-item flex-fill font-weight-bold">Especialidad:</li>
              <li class="list-group-item flex-fill">{{heroe.especialidad | capitalize}}</li>
            </ul>
            <ul class="list-group list-group-flush text-right">
              <li class="list-group-item text-muted">
                <small>Usuario Creado: {{heroe.user_creado | capitalize}}</small>
              </li>
              <li class="list-group-item text-muted">
                <small>Fecha Creado: {{heroe.fecha_creado | formatearFecha}}</small>
              </li>
              <li class="list-group-item text-muted" v-if="heroe.usuario_modifica">
                <small>Usuario Modificado: {{heroe.usuario_modifica | capitalize}}</small>
              </li>
              <li class="list-group-item text-muted" v-if="heroe.fecha_modificado">
                <small>Fecha Modificado: {{heroe.fecha_modificado | formatearFecha}}</small>
              </li>
            </ul>
            <div class="row justify-content-between mt-4">
              <router-link class="btn btn-info" :to="{name: 'Heroes'}">Heroes</router-link>
              <router-link class="btn btn-secondary" :to="{name: 'Heroes.editar', params: {codigo: heroe.codigo}}">Editar</router-link>
            </div>
          </div>
          <div v-else>
            <h1>{{mensaje}}</h1>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex';

export default {
  mounted() {
    this.getHeroe(this.$route.params.codigo);
  },
  data() {
    return {
      heroe: [],
      mensaje: 'Buscando contenido'
    }
  },
  methods: {
    getHeroe(codigo) {
      let config = {
        headers: {
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token.token}`,
          'apikey': this.usuario.apikey
        }
      }
      this.axios.get(`/v1/heroes/${codigo}`, config)
        .then(result => {
          Toast.fire({
            icon: 'success',
            title: result.data.message
          })
          this.heroe = result.data.body.heroe
        })
        .catch(e => {
          Toast.fire({
            icon: 'error',
            title: e.response.data.message
          })
          setTimeout(() => {
            this.$router.push({name: 'Heroes'})
          }, 3000);
        })
    }
  },
  computed: {
    ...mapState('usuario', ['usuario', 'token'])
  }
}
</script>

<style scoped>
.list-group-item {
  border: none !important;
}
.text-muted {
  padding-top: 0px !important;
  padding-bottom: 0px !important;
}
</style>
